summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorRémy Oudompheng <remy@archlinux.org>2011-07-14 18:08:11 +0200
committerRémy Oudompheng <remy@archlinux.org>2011-07-14 18:20:50 +0200
commitca7c9bb5514d2026d06a33031e93f1d79a70301f (patch)
treeaa553baf8c829355550eb915151892f590fe45f0
parent5abcb9b8c5c7839483ad732caba5b2908533940e (diff)
downloadnetctl-ca7c9bb5514d2026d06a33031e93f1d79a70301f.tar.gz
netctl-ca7c9bb5514d2026d06a33031e93f1d79a70301f.tar.xz
bond: add minimal support for interface bonding (FS#24802)
Contributed-by: Byron Williams <byron@112percent.com> Signed-off-by: Rémy Oudompheng <remy@archlinux.org>
-rw-r--r--README3
-rw-r--r--src/connections/bond49
2 files changed, 52 insertions, 0 deletions
diff --git a/README b/README
index 7121de0..6ce4702 100644
--- a/README
+++ b/README
@@ -14,6 +14,9 @@ For wireless support:
- wpa_supplicant
- wpa_actiond: for automatic connection
+For bonding support
+- ifenslave
+
Deprecated dependencies:
- net-tools (only used in IFOPTS option)
- wireless_tools (only used for IWCONFIG option, still necessary for wireless connection)
diff --git a/src/connections/bond b/src/connections/bond
new file mode 100644
index 0000000..6ba463e
--- /dev/null
+++ b/src/connections/bond
@@ -0,0 +1,49 @@
+#! /bin/bash
+. /usr/lib/network/network
+IFENSLAVE="/sbin/ifenslave"
+
+bond_up() {
+ load_profile "$1"
+
+ if [ -e /sys/class/net/$INTERFACE ]; then
+ report_fail "Interface $INTERFACE already exists."
+ exit 1
+ else
+ ip link add dev $INTERFACE type bond
+ fi
+ bring_interface up "$INTERFACE"
+ "$CONN_DIR/ethernet" up "$1"
+
+ for slave in ${SLAVE_INTERFACES[@]}; do
+ bring_interface up "$INTERFACE"
+ $IFENSLAVE $INTERFACE $slave
+ done
+
+ return 0
+}
+
+bond_down() {
+ load_profile "$1"
+
+ for slave in ${SLAVE_INTERFACES[@]}; do
+ $IFENSLAVE $INTERFACE -d $slave
+ done
+
+ "$CONN_DIR/ethernet" down "$1"
+ bring_interface down "$INTERFACE"
+ ip link delete $INTERFACE &>/dev/null
+ return 0
+}
+
+bond_status() {
+ if [ -e /sys/class/net/$INTERFACE ]; then
+ return 0
+ else
+ return 1
+ fi
+}
+
+bond_$1 "$2"
+exit $?
+
+# vim: set ts=4 et sw=4: